---
- name: Windows Updates
  hosts: win
  tasks:
    - name: Create ansible-update directory if not exists
      ansible.windows.win_file:
        path: C:\Ansible-Update
        state: directory

    - name: Install Windows Updates with retries
      ansible.windows.win_updates:
        category_names: '*'
        state: installed
        reboot: false
        log_path: C:\Ansible-Update\ansible-{{ ansible_date_time.date }}.txt
      register: update_result
      retries: 2  
      delay: 180  
      until: update_result.failed is not defined or update_result.failed == false
      failed_when: update_result.failed_update_count > 0  
      ignore_errors: yes  

    - name: Print detailed update results
      debug:
        msg:
          - "Server: {{ inventory_hostname }}"
          - "Found Updates: {{ update_result.found_update_count }}"
          - "Installed Updates: {{ update_result.installed_update_count }}"
          - "Failed Updates: {{ update_result.failed_update_count }}"
      when: update_result is defined

    - name: Check if any update failed and mark failure
      fail:
        msg:
          - "Server: {{ inventory_hostname }} - Windows updates failed after 2 retries."
          - "Found Updates: {{ update_result.found_update_count }}"
          - "Installed Updates: {{ update_result.installed_update_count }}"
          - "Failed Updates: {{ update_result.failed_update_count }}"
      when: update_result.failed_update_count > 0

    - name: Notify successful installation if no updates failed
      debug:
        msg: "Server: {{ inventory_hostname }} - Windows updates successfully installed."
      when: update_result.failed_update_count == 0
